program Lista_ordenada;

Uses Crt,Dos;

Type  Elem  = Char;
      Lista = ^Nodo;
      Nodo = Record
           Obj : Elem;
           Prox : Lista;
      End;

Var L : Lista;

Procedure Usuario_Escreve;
Var
   X : Char;
Begin
  Clrscr;
  GotoXY(25,12);Write('Digite o caracter...');
  GotoXY(25,13);Read(X);Readkey;
End;

Function Null(L : Lista) : Boolean;
{Testa a LISTA para ver se ela esta realmente VAZIA}
Begin
  Null := (L = Nil);
End;

Procedure Destruir(Var L : Lista);
Var
   P : Lista;
Begin
  While L <> Nil Do
    Begin
      P := L;
      L := L^.Prox;
      Dispose(L);
    End;
End;

Function Pesquisa(L : Lista; X : Elem) : Lista;
{Pesquisa NUM na LISTA}
Var
   P : Lista;
Begin
  Usuario_Escreve;
  P := L;
  While (P <> Nil) and (X > P^.Obj) Do
    P := P^.Prox;
  If (P <> Nil) and (X = P^.Obj) Then
    Pesquisa := P
  Else
    Pesquisa := Nil;
End;

Procedure Escolha; Forward;

Function Remover(Var L : Lista; X : Elem) : Boolean;
{Remove X na Lista}
Var P, Q : Lista;
Begin
  Usuario_Escreve;
  If Null(L) or (X > L^.Obj) Then
    Remover := False
  Else
    If X = L^.Obj Then
      Begin
        P := L;
        L := L^.Prox;
        Dispose(P);
        Remover := True;
      End
    Else
      Begin
        P := L;
        While (P^.Prox <> Nil) and (X > P^.Prox^.Obj) Do
          P := P^.Prox;
        If (P^.Prox <> Nil) and ( X = P^.Prox^.Obj) Then
          Begin
            Q := P^.Prox;
            P^.Prox := Q^.Prox;
            Dispose(Q);
            Remover := True;
          End
        Else
          Remover := False;
      End;
   Escolha;
End;


Procedure Inserir(L : Lista; X : Elem);
Var
   N : Lista;
Begin
  Usuario_Escreve;
  New(N);
  N^.Obj := X;
  While (L^.Prox <> Nil) and (X > L^.Prox^.Obj) Do
    L := L^.Prox;
  N^.Prox := L^.Prox;
  L^.Prox := N;
  Escolha;
End;



Procedure Criar(L : Lista);
{Inicializa a lista com o valor nulo, VAZIA}
Begin
  L := Nil;
  Usuario_escreve;
  Inserir(l,'X');
End;

Procedure Imprimir(Nome : Char; L : Lista);
Var
   P : Lista;
Begin
  P := L;
  Write(Nome,':[');
  While P <> Nil Do
    Begin
      Write(P^.Obj,',');
      P := P^.Prox;
    End;
  Writeln(']');
End;

Procedure Menu;
Begin
  GotoXY(25,10);Write('1 _ Criar Lista');
  GotoXY(25,11);Write('2 _ Inserir');
  GotoXY(25,12);Write('3 _ Deletar');
  GotoXY(25,13);Write('4 _ Buscar');
  GotoXY(25,14);Write('5 _ Excluir Lista');
End;

Procedure Escolha;
Var
   Opcao : Byte;
Begin
  GotoXY(2,23);Write('Opcao:');
  GotoXY(8,23);Read(Opcao);
  Case Opcao Of
    1 : Criar(L);
    2 : Inserir(l,'X');
    3 : Remover(L,'X');
    4 : Pesquisa(L,'X');
    5 : Destruir(L);
  End;
End;

Begin
  Clrscr;
  Menu;
  Escolha;
  Readkey;
End.