Uses Crt,Dos;

Type  Elem  = Char;
      Lista = ^Nodo;
      Nodo = Record
           Obj : Elem;
           Prox : Lista;
      End;
Var L : Lista;

Procedure Create(L : Lista);
{Inicializa a lista com o valor nulo, VAZIA}
Begin
  L := Nil;
End;

Function Null(L : Lista) : Boolean;
{Testa a LISTA para ver se ela esta realmente VAZIA}
Begin
  Null := (L = Nil);
End;

Function Remove(Var L : Lista; X : Elem) : Boolean;
{Remove na Lista}
Var P, Q : Lista;
Begin
  If Null(L) or (X > L^.Obj) Then
    Remove := False
  Else
    If X = L^.Obj Then
      Begin
        P := L;
        L := L^.Prox;
        Dispose(P);
        Remove := True;
      End
    Else
      Begin
        P := L;
        While (P^.Prox <> Nil) and (X > P^.Prox^.Obj) Do
          P := P^.Prox;
        If (P^.Prox <> Nil) and ( X = P^.Prox^.Obj) Then
          Begin
            Q := P^.Prox;
            P^.Prox := Q^.Prox;
            Dispose(Q);
            Remove := True;
          End
        Else
          Remove := False;
      End;
End;

Function Pesquisa(L : Lista; X : Elem) : Lista;
{Pesquisa NUM na LISTA}
Var
   P : Lista;
Begin
  P := L;
  While (P <> Nil) and (X > P^.Obj) Do
    P := P^.Prox;
  If (P <> Nil) and (X = P^.Obj) Then
    Pesquisa := P
  Else
    Pesquisa := Nil;
End;

Procedure Imprimir(Nome : Char; L : Lista);
Var
   P : Lista;
Begin
  P := L;
  Write(Nome,':[');
  While P <> Nil Do
    Begin
      Write(P^.Obj,',');
      P := P^.Prox;
    End;
  Writeln(']');
End;

Procedure Destruir(Var L : Lista);
Var
   P : Lista;
Begin
  While L <> Nil Do
    Begin
      P := L;
      L := L^.Prox;
      Dispose(L);
    End;
End;

